- Index

< Previous |  | Next >

# Kafka Admin Adapter

## Introduction

The TIBCO StreamBase® Output Adapter for Apache Kafka Admin allows StreamBase applications to perform various administration requests to an Apache Kafka broker.

The Apache Kafka adapter suite is implemented against the version of the Kafka libraries listed on the Supported Configurations page.

## Adapter Properties

This section describes the properties you can set for this adapter, using the various tabs of the Properties view in StreamBase Studio.

### General Tab

Name: Use this required field to specify or change the component's name, which must be unique in the current module. The name must contain only alphabetic characters, numbers, and underscores, and no hyphens or other special characters. The first character must be alphabetic or an underscore.

Adapter: A read-only field that shows the formal name of the adapter.

Start with application: If this field is set to Yes (default) or to a module parameter that evaluates to `true`, this instance of this adapter starts as part of the JVM engine that runs this EventFlow fragment. If this field is set to No or to a module parameter that evaluates to `false`, the adapter instance is loaded with the engine, but does not start until you send an epadmin container resume command (or its sbadmin equivalent), or until you start the component with StreamBase Manager.

Enable Error Output Port: Select this check box to add an Error Port to this component. In the EventFlow canvas, the Error Port shows as a red output port, always the last port for the component. See Using Error Ports to learn about Error Ports.

Description: Optionally enter text to briefly describe the component's purpose and function. In the EventFlow canvas, you can see the description by pressing Ctrl while the component's tooltip is displayed.

### Adapter Properties Tab

Property | Type | Description
--- | --- | ---
Zookeepers | string | A comma-separated list of address:ports specifying one or more Apache ZooKeeper servers to connect to for issuing commands. The default value is `localhost:2181`
Enable Topics Port | check box | When selected, specifies that the adapter sends topic information on its topics port when the adapter receives a topics command. The default value is selected.
Enable Brokers Port | check box | When selected, specifies that the adapter sends broker information on its brokers port when the adapter receives a brokers command. The default value is selected.
Enable Read Value Port | check box | When selected, specifies that the adapter outputs value information on its read value Port based on a readValue command. The default value is selected.
Enable Status Port | check box | When selected, the adapter sends out informational data on its Status Port about various states of the adapter. The default value is cleared.
Session Timeout (MS) | int | The Zookeeper session timeout in milliseconds. Default: 6000 milliseconds.
Connection Timeout (MS) | int | The Zookeeper connection timeout in milliseconds. Default: 6000 milliseconds.
Log Level | drop-down list | Controls the level of verbosity the adapter uses to issue informational traces to the console. This setting is independent of the containing application's overall log level. Available values, in increasing order of verbosity, are: OFF, ERROR, WARN, INFO, DEBUG, TRACE.

### Concurrency Tab

Use the Concurrency tab to specify parallel regions for this instance of this component, or multiplicity options, or both. The Concurrency tab settings are described in Concurrency Options, and dispatch styles are described in Dispatch Styles.

### Caution

Concurrency settings are not suitable for every application, and using these settings requires a thorough analysis of your application. For details, see Execution Order and Concurrency, which includes important guidelines for using the concurrency options.

## Command Input Port

The Command input port is always enabled by default. Use the command port to send action commands to the Kafka Admin adapter.

The minimum schema for the command input port is a single field named `command` of type string. A command port with this schema can accept the `brokers` and `topics` commands, to generate output on the brokers and topics output ports.

The suggested full schema for the command input port is the following:

- command, string. The command to send to the adapter. Valid values are: createTopic, deleteTopic, brokers, writeValue, readValue, topics.

- topic (optional), string. The topic from which to subscribe and unsubscribe.

- partition (optional), integer. The partition to subscribe to, leave null for default of 0.

- replication, integer.

- properties, list(tuple). Where the tuple's schema is key (string), value (string).

- path, string.

- value, string.

- createMode, string.

## Topics Output Port

### Description

The topics port, when enabled in the Adapter Properties tab of the Properties view, emits tuples in response to a `topics` command.

### Topics Port Schema

- topics, list(tuple). One list member for each topic. The schema of the tuple is:

  - topic, string. The name of this topic.

  - properties, list(tuple). Where the tuple's schema is key (string), value (string).

  - partitions, list(integer) —

## Brokers Output Port

### Description

The brokers port, when enabled in the Adapter Properties tab of the Properties view, emits tuples in response to a `brokers` command.

### Brokers Port Schema

- topics, list(tuple). One list member for each broker. The schema of the tuple is:

  - host, string —

  - port, integer —

  - id, integer —

## Read Value Output Port

### Description

The read value port, when enabled in the Adapter Properties tab of the Properties view, emits tuples in response to a `readValue` command.

### Read Value Port Schema

- path, string —

- value, string —

## Status Output Port

### Description

The status port is used to send status information tuples downstream to inform the user of changes.

The status port, when enabled in the Adapter Properties tab of the Properties view, emits status information tuples downstream to inform the user of changes.

### Status Port Schema

- type, string. The type of status information emitted on this port. Status types are:

  - Error — This message relates to an error that occurred.

  - Warn —This message relates to a warning that the user should be aware of.

  - Info — This message relates to extra status information.

- action, string. A specific action related to this status message.

- object, string. This value may be null. If it is not null, it contains a value relevant to the status message.

- message, string. This is a formatted human readable message that explains the status message.

- time, timestamp. The time the status message occurred.

## Related Topics

- TIBCO StreamBase® adapter for Apache Kafka Consumer

- TIBCO StreamBase® Adapter for Apache Kafka Consumer Commit

- TIBCO StreamBase® Adapter for Apache Kafka Producer

- Using Embedded Adapters